import fileIO._
import correctdata._
import scala.io._

/**
 * ASAの比較実験をする"compare.scala"で使用できる形式の正解データcsvの生成
 */
object convetCorrectDataCsv {
	val Reader = new CsvReader
	val ReadWBCCJ = new readWBCCJanotate
	val Extract = new Extraction

	def main(args: Array[String]): Unit = {
		var outfile: String = ""
		var infile: String = ""
		var itype: String = "vth"
			
		// infile = "/home1/ex/ikeda/data/decided_20140823.tsv"
		infile = "/home1/ex/ikeda/data/vths20141008.csv"
		outfile = "/home1/ex/ikeda/data/vth20141008_correct.csv"
		itype = "vth" //vth or wbccj

		println("-start-")
		itype match {
			case "vth" => convertVth(infile, outfile)
			case "wbccj" => convertWBCCJ(infile, outfile)
			case _ =>
		}
		println("-done-")
	}

	def convertVth(infile: String, outfile: String) {
		val orignal = Source.fromFile(infile).getLines.map(Reader.parseLine(_).get).toList
		val csvs = Extract.extractVth(orignal.tail)
		new CsvWriter(outfile).output(csvs)
	}

	def convertWBCCJ(infile: String, outfile: String) {
		val orignal = ReadWBCCJ.wbccj(infile)
		val csvs = Extract.extractWBCCJ(orignal)
		new CsvWriter(outfile).output(csvs)
	}
}